GenericDeploymentTool (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.ejb, class: GenericDeploymentTool

Package org.apache.tools.ant.taskdefs.optional.ejb

# Class GenericDeploymentTool

java.lang.Object
org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool

All Implemented Interfaces:
  `EJBDeploymentTool`

Direct Known Subclasses:
  `BorlandDeploymentTool`, `IPlanetDeploymentTool`, `JbossDeploymentTool`, `JonasDeploymentTool`, `OrionDeploymentTool`, `WeblogicDeploymentTool`, `WebsphereDeploymentTool`

public class GenericDeploymentTool extends Object implements EJBDeploymentTool
A deployment tool which creates generic EJB jars. Generic jars contains only those classes and META-INF entries specified in the EJB 1.1 standard This class is also used as a framework for the creation of vendor specific deployment tools. A number of template methods are provided through which the vendor specific tool can hook into the EJB creation process.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ANALYZER_CLASS_FULL`
  The analyzer class for the super analyzer
  `static final String`
  `ANALYZER_CLASS_SUPER`
  The analyzer class for the super analyzer
  `static final String`
  `ANALYZER_FULL`
  A dependency analyzer name to find all related classes
  `static final String`
  `ANALYZER_NONE`
  A dependency analyzer name for no analyzer
  `static final String`
  `ANALYZER_SUPER`
  A dependency analyzer name to find ancestor classes
  `static final String`
  `DEFAULT_ANALYZER`
  The default analyzer
  `static final int`
  `DEFAULT_BUFFER_SIZE`
  The default buffer byte size to use for IO
  `protected static final String`
  `EJB_DD`
  Name for EJB Deployment descriptor within EJB jars
  `static final int`
  `JAR_COMPRESS_LEVEL`
  The level to use for compression
  `protected static final String`
  `MANIFEST`
  The standard MANIFEST file
  `protected static final String`
  `META_DIR`
  The standard META-INF directory in jar files

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GenericDeploymentTool()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `addFileToJar(JarOutputStream jStream, File inputFile, String logicalFilename)`
  Utility method that encapsulates the logic of adding a file entry to a .jar file.
  `protected void`
  `addSupportClasses(Hashtable<String,File> ejbFiles)`
  Adds any classes the user specifies using support nested elements to the `ejbFiles` Hashtable.
  `protected void`
  `addVendorFiles(Hashtable<String,File> ejbFiles, String ddPrefix)`
  Add any vendor specific files which should be included in the EJB Jar.
  `protected void`
  `checkAndAddDependants(Hashtable<String,File> checkEntries)`
  Add all available classes, that depend on Remote, Home, Bean, PK
  `protected void`
  `checkConfiguration(String descriptorFileName, SAXParser saxParser)`
  This method is called as the first step in the processDescriptor method to allow vendor-specific subclasses to validate the task configuration prior to processing the descriptor.
  `void`
  `configure(org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config config)`
  Configure this tool for use in the ejbjar task.
  `Path`
  `createClasspath()`
  Add the classpath for the user classes
  `protected ClassLoader`
  `getClassLoaderForBuild()`
  Returns a Classloader object which parses the passed in generic EjbJar classpath.
  `protected Path`
  `getCombinedClasspath()`
  Get the classpath by combining the one from the surrounding task, if any and the one from this tool.
  `protected org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config`
  `getConfig()`
  Get the basename terminator.
  `protected DescriptorHandler`
  `getDescriptorHandler(File srcDir)`
  Get a descriptionHandler.
  `protected File`
  `getDestDir()`
  Get the destination directory.
  `protected String`
  `getJarBaseName(String descriptorFileName)`
  Using the EJB descriptor file name passed from the `ejbjar` task, this method returns the "basename" which will be used to name the completed JAR file.
  `protected Location`
  `getLocation()`
  Get the build file location associated with this element's task.
  `protected File`
  `getManifestFile(String prefix)`
  Get the manifest file to use for building the generic jar.
  `protected String`
  `getPublicId()`
  Returns the Public ID of the DTD specified in the EJB descriptor.
  `protected Task`
  `getTask()`
  Get the task for this tool.
  `String`
  `getVendorDDPrefix(String baseName, String descriptorFileName)`
  Get the prefix for vendor deployment descriptors.
  `protected void`
  `log(String message, int level)`
  Log a message to the Ant output.
  `protected boolean`
  `needToRebuild(Hashtable<String,File> ejbFiles, File jarFile)`
  This method checks the timestamp on each file listed in the `ejbFiles` and compares them to the timestamp on the `jarFile` .
  `protected Hashtable<String,File>`
  `parseEjbFiles(String descriptorFileName, SAXParser saxParser)`
  This method returns a list of EJB files found when the specified EJB descriptor is parsed and processed.
  `void`
  `processDescriptor(String descriptorFileName, SAXParser saxParser)`
  Process a deployment descriptor, generating the necessary vendor specific deployment files.
  `protected void`
  `registerKnownDTDs(DescriptorHandler handler)`
  Register the locations of all known DTDs.
  `void`
  `setClasspath(Path classpath)`
  Set the classpath to be used for this compilation.
  `void`
  `setDestdir(File inDir)`
  Set the destination directory; required.
  `void`
  `setGenericJarSuffix(String inString)`
  Set the suffix for the generated jar file.
  `void`
  `setTask(Task task)`
  Set the task which owns this tool
  `protected boolean`
  `usingBaseJarName()`
  Indicate if this build is using the base jar name.
  `void`
  `validateConfigured()`
  Called to validate that the tool parameters have been configured.
  `protected void`
  `writeJar(String baseName, File jarfile, Hashtable<String,File> files, String publicId)`
  Method used to encapsulate the writing of the JAR file.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_BUFFER_SIZE

    public static final int DEFAULT_BUFFER_SIZE
    The default buffer byte size to use for IO
    See Also:
      - Constant Field Values

  - ### JAR_COMPRESS_LEVEL

    public static final int JAR_COMPRESS_LEVEL
    The level to use for compression
    See Also:
      - Constant Field Values

  - ### META_DIR

    protected static final String META_DIR
    The standard META-INF directory in jar files
    See Also:
      - Constant Field Values

  - ### MANIFEST

    protected static final String MANIFEST
    The standard MANIFEST file
    See Also:
      - Constant Field Values

  - ### EJB_DD

    protected static final String EJB_DD
    Name for EJB Deployment descriptor within EJB jars
    See Also:
      - Constant Field Values

  - ### ANALYZER_SUPER

    public static final String ANALYZER_SUPER
    A dependency analyzer name to find ancestor classes
    See Also:
      - Constant Field Values

  - ### ANALYZER_FULL

    public static final String ANALYZER_FULL
    A dependency analyzer name to find all related classes
    See Also:
      - Constant Field Values

  - ### ANALYZER_NONE

    public static final String ANALYZER_NONE
    A dependency analyzer name for no analyzer
    See Also:
      - Constant Field Values

  - ### DEFAULT_ANALYZER

    public static final String DEFAULT_ANALYZER
    The default analyzer
    See Also:
      - Constant Field Values

  - ### ANALYZER_CLASS_SUPER

    public static final String ANALYZER_CLASS_SUPER
    The analyzer class for the super analyzer
    See Also:
      - Constant Field Values

  - ### ANALYZER_CLASS_FULL

    public static final String ANALYZER_CLASS_FULL
    The analyzer class for the super analyzer
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### GenericDeploymentTool

    public GenericDeploymentTool()

- ## Method Details

  - ### setDestdir

    public void setDestdir(File inDir)
    Set the destination directory; required.
    Parameters:
      `inDir` - the destination directory.

  - ### getDestDir

    protected File getDestDir()
    Get the destination directory.
    Returns:
      the destination directory into which EJB jars are to be written

  - ### setTask

    public void setTask(Task task)
    Set the task which owns this tool
    Specified by:
      `setTask` in interface `EJBDeploymentTool`
    Parameters:
      `task` - the Task to which this deployment tool is associated.

  - ### getTask

    protected Task getTask()
    Get the task for this tool.
    Returns:
      the Task instance this tool is associated with.

  - ### getConfig

    protected org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config getConfig()
    Get the basename terminator.
    Returns:
      an ejbjar task configuration

  - ### usingBaseJarName

    protected boolean usingBaseJarName()
    Indicate if this build is using the base jar name.
    Returns:
      true if the name of the generated jar is coming from the basejarname attribute

  - ### setGenericJarSuffix

    public void setGenericJarSuffix(String inString)
    Set the suffix for the generated jar file.
    Parameters:
      `inString` - the string to use as the suffix.

  - ### createClasspath

    public Path createClasspath()
    Add the classpath for the user classes
    Returns:
      a Path instance to be configured by Ant.

  - ### setClasspath

    public void setClasspath(Path classpath)
    Set the classpath to be used for this compilation.
    Parameters:
      `classpath` - the classpath to be used for this build.

  - ### getCombinedClasspath

    protected Path getCombinedClasspath()
    Get the classpath by combining the one from the surrounding task, if any and the one from this tool.
    Returns:
      the combined classpath

  - ### log

    protected void log(String message, int level)
    Log a message to the Ant output.
    Parameters:
      `message` - the message to be logged.
      `level` - the severity of this message.

  - ### getLocation

    protected Location getLocation()
    Get the build file location associated with this element's task.
    Returns:
      the task's location instance.

  - ### configure

    public void configure(org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config config)
    Configure this tool for use in the ejbjar task.
    Specified by:
      `configure` in interface `EJBDeploymentTool`
    Parameters:
      `config` - the configuration from the surrounding ejbjar task.

  - ### addFileToJar

    protected void addFileToJar(JarOutputStream jStream, File inputFile, String logicalFilename) throws BuildException
    Utility method that encapsulates the logic of adding a file entry to a .jar file. Used by execute() to add entries to the jar file as it is constructed.
    Parameters:
      `jStream` - A JarOutputStream into which to write the jar entry.
      `inputFile` - A File from which to read the contents the file being added.
      `logicalFilename` - A String representing the name, including all relevant path information, that should be stored for the entry being added.
    Throws:
      `BuildException` - if there is a problem.

  - ### getDescriptorHandler

    protected DescriptorHandler getDescriptorHandler(File srcDir)
    Get a descriptionHandler.
    Parameters:
      `srcDir` - the source directory.
    Returns:
      a handler.

  - ### registerKnownDTDs

    protected void registerKnownDTDs(DescriptorHandler handler)
    Register the locations of all known DTDs. vendor-specific subclasses should override this method to define the vendor-specific locations of the EJB DTDs
    Parameters:
      `handler` - no used in this class.

  - ### processDescriptor

    public void processDescriptor(String descriptorFileName, SAXParser saxParser)
    Process a deployment descriptor, generating the necessary vendor specific deployment files..
    Specified by:
      `processDescriptor` in interface `EJBDeploymentTool`
    Parameters:
      `descriptorFileName` - the name of the deployment descriptor
      `saxParser` - a SAX parser which can be used to parse the deployment descriptor.

  - ### checkConfiguration

    protected void checkConfiguration(String descriptorFileName, SAXParser saxParser) throws BuildException
    This method is called as the first step in the processDescriptor method to allow vendor-specific subclasses to validate the task configuration prior to processing the descriptor. If the configuration is invalid, a BuildException should be thrown.
    Parameters:
      `descriptorFileName` - String representing the file name of an EJB descriptor to be processed
      `saxParser` - SAXParser which may be used to parse the XML descriptor
    Throws:
      `BuildException` - if there is a problem.

  - ### parseEjbFiles

    protected Hashtable<String,File> parseEjbFiles(String descriptorFileName, SAXParser saxParser) throws IOException, SAXException
    This method returns a list of EJB files found when the specified EJB descriptor is parsed and processed.
    Parameters:
      `descriptorFileName` - String representing the file name of an EJB descriptor to be processed
      `saxParser` - SAXParser which may be used to parse the XML descriptor
    Returns:
      Hashtable of EJB class (and other) files to be added to the completed JAR file
    Throws:
      `SAXException` - Any SAX exception, possibly wrapping another exception
      `IOException` - An IOException from the parser, possibly from a the byte stream or character stream

  - ### addSupportClasses

    protected void addSupportClasses(Hashtable<String,File> ejbFiles)
    Adds any classes the user specifies using support nested elements to the `ejbFiles` Hashtable.
    Parameters:
      `ejbFiles` - Hashtable of EJB classes (and other) files that will be added to the completed JAR file

  - ### getJarBaseName

    protected String getJarBaseName(String descriptorFileName)
    Using the EJB descriptor file name passed from the `ejbjar` task, this method returns the "basename" which will be used to name the completed JAR file.
    Parameters:
      `descriptorFileName` - String representing the file name of an EJB descriptor to be processed
    Returns:
      The "basename" which will be used to name the completed JAR file

  - ### getVendorDDPrefix

    public String getVendorDDPrefix(String baseName, String descriptorFileName)
    Get the prefix for vendor deployment descriptors. This will contain the path and the start of the descriptor name, depending on the naming scheme
    Parameters:
      `baseName` - the base name to use.
      `descriptorFileName` - the file name to use.
    Returns:
      the prefix.

  - ### addVendorFiles

    protected void addVendorFiles(Hashtable<String,File> ejbFiles, String ddPrefix)
    Add any vendor specific files which should be included in the EJB Jar.
    Parameters:
      `ejbFiles` - a hashtable entryname -> file.
      `ddPrefix` - a prefix to use.

  - ### needToRebuild

    protected boolean needToRebuild(Hashtable<String,File> ejbFiles, File jarFile)
    This method checks the timestamp on each file listed in the `ejbFiles` and compares them to the timestamp on the `jarFile` . If the `jarFile`'s timestamp is more recent than each EJB file, `true` is returned. Otherwise, `false` is returned. TODO: find a way to check the manifest-file, that is found by naming convention
    Parameters:
      `ejbFiles` - Hashtable of EJB classes (and other) files that will be added to the completed JAR file
      `jarFile` - JAR file which will contain all of the EJB classes (and other) files
    Returns:
      boolean indicating whether or not the `jarFile` is up to date

  - ### getPublicId

    protected String getPublicId()
    Returns the Public ID of the DTD specified in the EJB descriptor. Not every vendor-specific `DeploymentTool` will need to reference this value or may want to determine this value in a vendor-specific way.
    Returns:
      Public ID of the DTD specified in the EJB descriptor.

  - ### getManifestFile

    protected File getManifestFile(String prefix)
    Get the manifest file to use for building the generic jar. If the file does not exist the global manifest from the config is used otherwise the default Ant manifest will be used.
    Parameters:
      `prefix` - the prefix where to llook for the manifest file based on the naming convention.
    Returns:
      the manifest file or null if the manifest file does not exist

  - ### writeJar

    protected void writeJar(String baseName, File jarfile, Hashtable<String,File> files, String publicId) throws BuildException
    Method used to encapsulate the writing of the JAR file. Iterates over the filenames/java.io.Files in the Hashtable stored on the instance variable ejbFiles.
    Parameters:
      `baseName` - the base name to use.
      `jarfile` - the jar file to write to.
      `files` - the files to write to the jar.
      `publicId` - the id to use.
    Throws:
      `BuildException` - if there is a problem.

  - ### checkAndAddDependants

    protected void checkAndAddDependants(Hashtable<String,File> checkEntries) throws BuildException
    Add all available classes, that depend on Remote, Home, Bean, PK
    Parameters:
      `checkEntries` - files, that are extracted from the deployment descriptor
    Throws:
      `BuildException` - if there is a problem.

  - ### getClassLoaderForBuild

    protected ClassLoader getClassLoaderForBuild()
    Returns a Classloader object which parses the passed in generic EjbJar classpath. The loader is used to dynamically load classes from javax.ejb.* and the classes being added to the jar.
    Returns:
      a classloader.

  - ### validateConfigured

    public void validateConfigured() throws BuildException
    Called to validate that the tool parameters have been configured.
    Specified by:
      `validateConfigured` in interface `EJBDeploymentTool`
    Throws:
      `BuildException` - If the Deployment Tool's configuration isn't valid